#include <math.h>

void MoveLoopingBullet(
	float& x, float& y,    // 탄의 좌표
	float& vx, float& vy,  // 탄의 속도벡터
	float cx, float cy,    // 회전 중심의 좌표
	float r,               // 반경
	float theta,           // 각도(라디안)
	float omega            // 한 번 이동할 때 변화하는 각도(라디안)
) {
	// 각도를 변화시키기
	theta+=omega;

	// 위치를 계산하기
	x=cx+r*cos(theta);
	y=cy+r*sin(theta);

	// 탄의 속도(필요할 때만)
	vx=-r*omega*sin(theta);
	vy= r*omega*cos(theta);
}

void MoveLoopingBullet2(
	float& x, float& y,    // 탄의 좌표
	float& vx, float& vy,  // 탄의 속도
	float cx, float cy,    // 회전중심의 좌표
	float& r,              // 반경
	float vr,              // 반경의 변화
	float theta,           // 각도(라디안)
	float omega            // 한 번 이동할 때 변화하는 각도(라디안)
) {
	// 각도를 변화시키기
	theta+=omega;
	
	// 반경을 변화시키기
	r+=vr;

	// 위치를 계산하기
	x=cx+r*cos(theta);
	y=cy+r*sin(theta);

	// 탄의 속도(필요할 때만)
	vx=-r*omega*sin(theta);
	vy= r*omega*cos(theta);
}

