void DamageEnemy(int id);

void MoveReflectShot(
	float& x0, float& y0,      // 샷의 좌상좌표
	float& x1, float& y1,	   // 샷의 우하좌표
	float& vx, float& vy,	   // 샷의 속도(수평, 수직)
	float gx0[], float gy0[],  // 지형의 좌상좌표
	float gx1[], float gy1[],  // 지형의 우하좌표
	int num_ground,		   // 지형의 수
	float ex0[], float ey0[],  // 적기의 좌상좌표
	float ex1[], float ey1[],  // 적기의 우하좌표
	int num_enemy		   // 적기의 수
) {
	// 지형과의 접촉 판정 처리:
	// 샷을 수직방향으로 진행시킨 좌표에 대해
	// 지형에 접촉할지 아닐지를 판정함.
	// 지형에 닿을 경우에는 수직 방향의 속도를 역으로 하고
	// 루프를 빠져나옴.
	for (int i=0; i<num_ground; i++) {
		if (gx0[i]<x1 && x0<gx1[i] && 
			gy0[i]<y1+vy && y0+vy<gy1[i]) {
			vy=-vy;
			break;
		}
	}
	
	// 샷을 진행시키기
	x0+=vx; y0+=vy;
	x1+=vx; y1+=vy;

	// 적기와의 접촉 판정 처리:
	// 적기에 접촉했을 경우에는 적기에게 피해를 주고
	// 루프를 빠져나옴.
	// 적기에게 피해를 입히는 구체적인 처리는 DamageEnemy 함수에서 수행하기로 함.
	for (int i=0; i<num_enemy; i++) {
		if (ex0[i]<x1 && x0<ex1[i] && 
			ey0[i]<y1 && y0<ey1[i]) {
			DamageEnemy(i);
			break;
		}
	}
}

